#ifndef _AvrXSerialIo_h_
#define _AvrXSerialIo_h_
#include "AvrXFifo.h"
/*
	AvrSerialIo.h

	Sample code for fully buffered interrupt driven serial I/O for the
	AVR processor.  Uses the AvrXFifo facility.

	Author: Larry Barello (larry@barello.net)

	Revision History:

*/

// Buffer size can be anything from 2 to 32750
#define TX0_BUFSZ 400
#define RX0_BUFSZ 20

unsigned short crcUpdate(unsigned short crc, unsigned char serialData);

// Forward declarations
#ifndef _AVRXSERIALIO_C_	// Don't comingle this macro
	AVRX_EXT_FIFO(Rx0Buf);	// with the declaration macro.
	AVRX_EXT_FIFO(Tx0Buf);	// This block only active in
#endif

int get_c0(void);		// Non blocking, returns -1 when empty
int get_char0(void);	// Blocking, always returns character
int put_c0(char c);		// Non blocking, returns -1 when full
int put_char0(char c);	// Blocking, always returns 0.
int put_buffer0 (char *buf, int len);  // send data packet (lead in = 0x02)
int put_string0 (char *p);				// send log text string (lead in = 0x04)

void InitSerial0(uint16_t ubrr);

#endif //_AvrSerialIo_h_
